From 8d8717f8fbb9345ac51c3592cdb6c1f4f867aa7d Mon Sep 17 00:00:00 2001
From: Sahil Harpal <santosh.2@iitj.ac.in>
Date: Fri, 25 Aug 2023 13:10:10 +0530
Subject: [PATCH 3/3] Review-2 changes

---
 web/pgadmin/dashboard/static/js/Dashboard.jsx |   3 +
 .../dashboard/static/js/SystemStats/CPU.jsx   |   6 +-
 .../static/js/SystemStats/Memory.jsx          |   4 +-
 .../static/js/SystemStats/Storage.jsx         | 267 ++++++++++++++++--
 .../static/js/SystemStats/Summary.jsx         |  12 +-
 .../sql/default/system_statistics.sql         |  13 +
 .../js/components/PgChart/StreamingChart.jsx  |  15 +-
 7 files changed, 283 insertions(+), 37 deletions(-)

diff --git a/web/pgadmin/dashboard/static/js/Dashboard.jsx b/web/pgadmin/dashboard/static/js/Dashboard.jsx
index e6afeff07..2944a4e83 100644
--- a/web/pgadmin/dashboard/static/js/Dashboard.jsx
+++ b/web/pgadmin/dashboard/static/js/Dashboard.jsx
@@ -818,6 +818,8 @@ export default function Dashboard({
             const data = res.data;
             if(data['ss_present'] == false){
               setSsMsg(gettext('System stats extension is not installed. You can install the extension in a database using the "CREATE EXTENSION system_stats;" SQL command. Reload the pgAdmin once you installed.'));
+            } else {
+              setSsMsg(gettext(''));
             }
           })
           .catch(() => {
@@ -1034,6 +1036,7 @@ export default function Dashboard({
                             did={did}
                             pageVisible={props.panelVisible}
                             serverConnected={props.serverConnected}
+                            systemStatsTabVal={systemStatsTabVal}
                           />
                         </TabPanel>
                       </> :
diff --git a/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx b/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx
index a6341954f..e6b766767 100644
--- a/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx
+++ b/web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx
@@ -36,13 +36,11 @@ const useStyles = makeStyles((theme) => ({
   },
   container: {
     height: 'auto',
-    background: theme.palette.grey[200],
     padding: '10px',
     marginBottom: '30px',
   },
   fixedContainer: {
     height: '577px',
-    background: theme.palette.grey[200],
     padding: '10px',
     marginBottom: '30px',
   },
@@ -338,13 +336,13 @@ export function CPUWrapper(props) {
     <>
       <Grid container spacing={1} className={classes.container}>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('CPU Usage ()')}</div>
+          <div className={classes.containerHeader}>{gettext('CPU usage')}</div>
           <ChartContainer id='cu-graph' title={gettext('')} datasets={props.cpuUsageInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
             <StreamingChart data={props.cpuUsageInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
           </ChartContainer>
         </Grid>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('Load Average')}</div>
+          <div className={classes.containerHeader}>{gettext('Load average')}</div>
           <ChartContainer id='la-graph' title={gettext('')} datasets={props.loadAvgInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
             <StreamingChart data={props.loadAvgInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
           </ChartContainer>
diff --git a/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx b/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx
index 9d32795dd..8e8e0eb89 100644
--- a/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx
+++ b/web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx
@@ -27,13 +27,11 @@ const useStyles = makeStyles((theme) => ({
   },
   container: {
     height: 'auto',
-    background: theme.palette.grey[200],
     padding: '10px',
     marginBottom: '30px',
   },
   fixedContainer: {
     height: '577px',
-    background: theme.palette.grey[200],
     padding: '10px',
     marginBottom: '30px',
   },
@@ -339,7 +337,7 @@ export function MemoryWrapper(props) {
           </ChartContainer>
         </Grid>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('Swap Memory')}</div>
+          <div className={classes.containerHeader}>{gettext('Swap memory')}</div>
           <ChartContainer id='sm-graph' title={gettext('')} datasets={props.swapMemoryUsageInfo.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
             <StreamingChart data={props.swapMemoryUsageInfo} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
           </ChartContainer>
diff --git a/web/pgadmin/dashboard/static/js/SystemStats/Storage.jsx b/web/pgadmin/dashboard/static/js/SystemStats/Storage.jsx
index 2acb217bd..9db08b093 100644
--- a/web/pgadmin/dashboard/static/js/SystemStats/Storage.jsx
+++ b/web/pgadmin/dashboard/static/js/SystemStats/Storage.jsx
@@ -10,6 +10,7 @@ import { DATA_POINT_SIZE } from 'sources/chartjs';
 import StreamingChart from '../../../../static/js/components/PgChart/StreamingChart';
 import {useInterval, usePrevious} from 'sources/custom_hooks';
 import axios from 'axios';
+import { BarChart } from '../../../../static/js/chartjs';
 
 export const X_AXIS_LENGTH = 75;
 
@@ -26,22 +27,24 @@ const useStyles = makeStyles((theme) => ({
   },
   container: {
     height: 'auto',
-    background: theme.palette.grey[200],
     padding: '10px',
-    marginBottom: '30px',
+    marginBottom: '15px',
   },
   ioDiskContainer: {
     height: 'auto',
-    background: theme.palette.grey[200],
     padding: '10px',
   },
   fixedContainer: {
     height: '577px',
-    background: theme.palette.grey[200],
     padding: '10px',
     marginBottom: '30px',
+    overflowX: 'auto',
   },
   containerHeader: {
+    height: 'auto',
+    padding: '10px',
+  },
+  containerHeaderText: {
     fontSize: '16px',
     fontWeight: 'bold',
     marginBottom: '5px',
@@ -50,9 +53,37 @@ const useStyles = makeStyles((theme) => ({
     fontSize: '14px',
     fontWeight: 'bold',
     marginBottom: '5px',
-  }
+  },
+  table: {
+    width: '100%',
+    backgroundColor: theme.otherVars.tableBg,
+    border: '1px solid rgb(221, 224, 230)',
+    borderCollapse: 'collapse',
+    borderRadius: '4px',
+    overflow: 'hidden',
+  },
+  tableVal: {
+    border: '1px solid rgb(221, 224, 230) !important',
+    padding: '10px !important',
+  },
 }));
 
+export function formatBytes(bytes) {
+  if (bytes === null) {
+    return 'null';
+  }
+
+  const units = ['B', 'KB', 'MB', 'GB', 'TB'];
+  let unitIndex = 0;
+
+  while (bytes >= 1024 && unitIndex < units.length - 1) {
+    bytes /= 1024;
+    unitIndex++;
+  }
+
+  return `${bytes.toFixed(2)} ${units[unitIndex]}`;
+}
+
 export function transformData(labels, refreshRate) {
   const colors = ['#FF6384','#36A2EB','#FFCE56','#4BC0C0','#9966FF','#FF9F40','#8D6E63','#2196F3','#FFEB3B','#9C27B0','#00BCD4','#CDDC39'];
   let datasets = Object.keys(labels).map((label, i)=>{
@@ -120,10 +151,43 @@ const chartsDefault = {
   'io_stats': {},
 };
 
-export default function Storage({preferences, sid, did, pageVisible, enablePoll=true}) {
+
+const DiskStatsTable = (props) => {
+  const classes = useStyles();
+  const tableHeader = props.tableHeader;
+  const data = props.data;
+  return (
+    <table className={classes.table}>
+      <thead>
+        <tr>
+          {tableHeader.map((item, index) => (
+            <th className={classes.tableVal} key={index}>{item.Header}</th>
+          ))}
+        </tr>
+      </thead>
+      <tbody>
+        {data.map((item, index) => (
+          <tr className={classes.tableVal} key={index}>
+            {tableHeader.map((header, id) => (
+              <td className={classes.tableVal} key={header.accessor+'-'+id}>{item[header.accessor]}</td>
+            ))}
+          </tr>
+        ))}
+      </tbody>
+    </table>
+  );
+};
+
+DiskStatsTable.propTypes = {
+  data: PropTypes.array.isRequired,
+  tableHeader: PropTypes.array.isRequired,
+};
+
+export default function Storage({preferences, sid, did, pageVisible, enablePoll=true, systemStatsTabVal}) {
   const refreshOn = useRef(null);
   const prevPrefernces = usePrevious(preferences);
 
+  const [diskStats, setDiskStats] = useState([]);
   const [ioInfo, ioInfoReduce] = useReducer(ioStatsReducer, chartsDefault['io_stats']);
 
   const [, setCounterData] = useState({});
@@ -132,6 +196,49 @@ export default function Storage({preferences, sid, did, pageVisible, enablePoll=
   const [errorMsg, setErrorMsg] = useState(null);
   const [chartDrawnOnce, setChartDrawnOnce] = useState(false);
 
+  const tableHeader = [
+    {
+      Header: 'File system',
+      accessor: 'file_system',
+    },
+    {
+      Header: 'File system type',
+      accessor: 'file_system_type',
+    },
+    {
+      Header: 'Mount point',
+      accessor: 'mount_point',
+    },
+    {
+      Header: 'Drive letter',
+      accessor: 'drive_letter',
+    },
+    {
+      Header: 'Total space',
+      accessor: 'total_space',
+    },
+    {
+      Header: 'Used space',
+      accessor: 'used_space',
+    },
+    {
+      Header: 'Free space',
+      accessor: 'free_space',
+    },
+    {
+      Header: 'Total inodes',
+      accessor: 'total_inodes',
+    },
+    {
+      Header: 'Used inodes',
+      accessor: 'used_inodes',
+    },
+    {
+      Header: 'Free inodes',
+      accessor: 'free_inodes',
+    },
+  ];
+
   useEffect(()=>{
     let calcPollDelay = false;
     if(prevPrefernces) {
@@ -164,6 +271,50 @@ export default function Storage({preferences, sid, did, pageVisible, enablePoll=
     }
   }, [pageVisible]);
 
+  useEffect(() => {
+    try {
+      // Fetch the latest data point from the API endpoint
+      let url;
+      url = url_for('dashboard.system_statistics');
+      url += '/' + sid;
+      url += did > 0 ? '/' + did : '';
+      url += '?chart_names=' + 'di_stats';
+      axios.get(url)
+        .then((res) => {
+          let data = res.data;
+          setErrorMsg(null);
+          if(data.hasOwnProperty('di_stats')){
+            let di_info_list = [];
+            const di_info_obj = data['di_stats'];
+            for (const key in di_info_obj) {
+              di_info_list.push({ 
+                icon: '', 
+                file_system: di_info_obj[key]['file_system']?di_info_obj[key]['file_system']:'null',
+                file_system_type: di_info_obj[key]['file_system_type']?di_info_obj[key]['file_system_type']:'null',
+                mount_point: di_info_obj[key]['mount_point']?di_info_obj[key]['mount_point']:'null',
+                drive_letter: di_info_obj[key]['drive_letter']?di_info_obj[key]['drive_letter']:'null',
+                total_space: di_info_obj[key]['total_space']?formatBytes(di_info_obj[key]['total_space']):'null',
+                used_space: di_info_obj[key]['used_space']?formatBytes(di_info_obj[key]['used_space']):'null',
+                free_space: di_info_obj[key]['free_space']?formatBytes(di_info_obj[key]['free_space']):'null',
+                total_inodes: di_info_obj[key]['total_inodes']?di_info_obj[key]['total_inodes']:'null',
+                used_inodes: di_info_obj[key]['used_inodes']?di_info_obj[key]['used_inodes']:'null',
+                free_inodes: di_info_obj[key]['free_inodes']?di_info_obj[key]['free_inodes']:'null',
+                total_space_actual: di_info_obj[key]['total_space']?di_info_obj[key]['total_space']:null,
+                used_space_actual: di_info_obj[key]['used_space']?di_info_obj[key]['used_space']:null,
+                free_space_actual: di_info_obj[key]['free_space']?di_info_obj[key]['free_space']:null,
+              });
+            }
+            setDiskStats(di_info_list);
+          }
+        })
+        .catch((error) => {
+          console.error('Error fetching data:', error);
+        });
+    } catch (error) {
+      console.error('Error fetching data:', error);
+    }
+  }, [systemStatsTabVal, sid, did, enablePoll, pageVisible]);
+
   useInterval(()=>{
     const currEpoch = getEpoch();
     if(refreshOn.current === null) {
@@ -258,6 +409,8 @@ export default function Storage({preferences, sid, did, pageVisible, enablePoll=
         <StorageWrapper
           ioInfo={ioInfo}
           ioRefreshRate={preferences['io_stats_refresh']}
+          diskStats={diskStats}
+          tableHeader={tableHeader}
           errorMsg={errorMsg}
           showTooltip={preferences['graph_mouse_track']}
           showDataPoints={preferences['graph_data_points']}
@@ -276,6 +429,7 @@ Storage.propTypes = {
   did: PropTypes.oneOfType([PropTypes.string.isRequired, PropTypes.number.isRequired]),
   pageVisible: PropTypes.bool,
   enablePoll: PropTypes.bool,
+  systemStatsTabVal: PropTypes.number,
 };
 
 export function StorageWrapper(props) {
@@ -289,25 +443,88 @@ export function StorageWrapper(props) {
   const keys = Object.keys(props.ioInfo);
   return (
     <>
-      {keys.map((key, index) => (
-        index % 3 === 0 && (
-          <Grid key={`disk-${index}`} container spacing={1} className={classes.container}>
-            <Grid container spacing={1} className={classes.ioDiskContainer}>
-              <div className={classes.containerHeader}>{gettext(`Disk ${Math.floor(index / 3) + 1}`)}</div>
-            </Grid>
-            <Grid container spacing={1} className={classes.ioDiskContainer}>
-              {keys.slice(index, index + 3).map((innerKey, innerKeyIndex) => (
-                <Grid key={`${innerKey}`} item md={4} sm={6}>
-                  <div className={classes.chartHeader}>{innerKeyIndex==0 ? gettext('I/O Operations Count'): innerKeyIndex==1? gettext('Data Transfer (Bytes)'):gettext('Time Spent in I/O Operations (Milliseconds)')}</div>
-                  <ChartContainer id={`io-graph-${innerKey}`} title={gettext('')} datasets={transformData(props.ioInfo[innerKey], props.ioRefreshRate).datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
-                    <StreamingChart data={transformData(props.ioInfo[innerKey], props.ioRefreshRate)} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
-                  </ChartContainer>
-                </Grid>
-              ))}
-            </Grid>
+      <Grid container spacing={1} className={classes.container}>
+        <Grid container spacing={1} className={classes.containerHeader}>
+          <div className={classes.containerHeaderText}>{gettext('Disk information')}</div>
+        </Grid>
+        <Grid container spacing={1} className={classes.container}>
+          <DiskStatsTable tableHeader={props.tableHeader} data={props.diskStats} />
+        </Grid>
+        <Grid container spacing={1} className={classes.container}>
+          <Grid item md={6} sm={12}>
+            <ChartContainer id='ua-space-graph' title={gettext('')} datasets={[{borderColor: '#FF6384', label: 'Used space'}, {borderColor: '#36a2eb', label: 'Available space'}]}  errorMsg={props.errorMsg} isTest={props.isTest}>
+              <BarChart data={{
+                labels: props.diskStats.map((item, index) => item.mount_point!='null'?item.mount_point:item.drive_letter!='null'?item.drive_letter:'disk'+index),
+                datasets: [
+                  {
+                    label: 'Used space',
+                    data: props.diskStats.map((item) => item.used_space_actual?item.used_space_actual:0),
+                    backgroundColor: '#FF6384',
+                    borderColor: '#FF6384',
+                    borderWidth: 1,
+                  },
+                  {
+                    label: 'Available space',
+                    data: props.diskStats.map((item) => item.free_space_actual?item.free_space_actual:0),
+                    backgroundColor: '#36a2eb',
+                    borderColor: '#36a2eb',
+                    borderWidth: 1,
+                  },
+                ],
+              }}
+              options={
+                { 
+                  scales: {
+                    x: {
+                      display: true,
+                      ticks: {
+                        display: true,
+                      },
+                    },
+                    y: {
+                      beginAtZero: true,
+                      ticks: {
+                        callback: function (value) {
+                          return formatBytes(value);
+                        },
+                      },
+                    },
+                  },
+                  plugins: {
+                    legend: {
+                      display: false,
+                    },
+                  },
+                }
+              }
+              />
+            </ChartContainer>
           </Grid>
-        )
-      ))}
+          <Grid item md={6} sm={12}>
+          </Grid>
+        </Grid>
+      </Grid>
+      <Grid container spacing={1} className={classes.container}>
+        {keys.map((key, index) => (
+          index % 3 === 0 && (
+            <Grid key={`disk-${index}`} container spacing={1} className={classes.container}>
+              <Grid container spacing={1} className={classes.containerHeader}>
+                <div className={classes.containerHeaderText}>{gettext(`Disk ${Math.floor(index / 3) + 1}`)}</div>
+              </Grid>
+              <Grid container spacing={1} className={classes.ioDiskContainer}>
+                {keys.slice(index, index + 3).map((innerKey, innerKeyIndex) => (
+                  <Grid key={`${innerKey}`} item md={4} sm={6}>
+                    <div className={classes.chartHeader}>{innerKeyIndex==0 ? gettext('I/O operations count'): innerKeyIndex==1? gettext('Data transfer (bytes)'):gettext('Time spent in I/O operations (milliseconds)')}</div>
+                    <ChartContainer id={`io-graph-${innerKey}`} title={gettext('')} datasets={transformData(props.ioInfo[innerKey], props.ioRefreshRate).datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
+                      <StreamingChart data={transformData(props.ioInfo[innerKey], props.ioRefreshRate)} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} />
+                    </ChartContainer>
+                  </Grid>
+                ))}
+              </Grid>
+            </Grid>
+          )
+        ))}
+      </Grid>
     </>
   );
 }
@@ -320,6 +537,8 @@ StorageWrapper.propTypes = {
     })
   ),
   ioRefreshRate: PropTypes.number.isRequired,
+  diskStats: PropTypes.array.isRequired,
+  tableHeader: PropTypes.array.isRequired,
   errorMsg: PropTypes.string,
   showTooltip: PropTypes.bool.isRequired,
   showDataPoints: PropTypes.bool.isRequired,
diff --git a/web/pgadmin/dashboard/static/js/SystemStats/Summary.jsx b/web/pgadmin/dashboard/static/js/SystemStats/Summary.jsx
index 9b2ee9a30..1cda27a01 100644
--- a/web/pgadmin/dashboard/static/js/SystemStats/Summary.jsx
+++ b/web/pgadmin/dashboard/static/js/SystemStats/Summary.jsx
@@ -30,6 +30,9 @@ const useStyles = makeStyles((theme) => ({
     width: '100%',
     backgroundColor: theme.otherVars.tableBg,
     border: '1px solid rgb(221, 224, 230)',
+    borderCollapse: 'collapse',
+    borderRadius: '4px',
+    overflow: 'hidden',
   },
   tableVal: {
     border: '1px solid rgb(221, 224, 230) !important',
@@ -37,7 +40,6 @@ const useStyles = makeStyles((theme) => ({
   },
   container: {
     height: 'auto',
-    background: theme.palette.grey[200],
     padding: '10px',
     marginBottom: '30px',
   },
@@ -381,11 +383,11 @@ export function SummaryWrapper(props) {
     <>
       <Grid container spacing={1} className={classes.container}>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('OS Information')}</div>
+          <div className={classes.containerHeader}>{gettext('OS information')}</div>
           <SummaryTable data={props.osStats} />
         </Grid>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('Handle & Process Count')}</div>
+          <div className={classes.containerHeader}>{gettext('Handle & process count')}</div>
           <ChartContainer id='hpc-graph' title={gettext('')} datasets={props.processHandleCount.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
             <StreamingChart data={props.processHandleCount} dataPointSize={DATA_POINT_SIZE} xRange={X_AXIS_LENGTH} options={options} showSecondAxis={true} />
           </ChartContainer>
@@ -393,11 +395,11 @@ export function SummaryWrapper(props) {
       </Grid>
       <Grid container spacing={1} className={classes.container}>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('CPU Information')}</div>
+          <div className={classes.containerHeader}>{gettext('CPU information')}</div>
           <SummaryTable data={props.cpuStats} />
         </Grid>
         <Grid item md={6} sm={12}>
-          <div className={classes.containerHeader}>{gettext('Process Information')}</div>
+          <div className={classes.containerHeader}>{gettext('Process information')}</div>
           <ChartContainer id='pi-graph' title={gettext('')} datasets={props.processInfoStats.datasets}  errorMsg={props.errorMsg} isTest={props.isTest}>
             <DonutChart data={props.processInfoStats.datasets} />
           </ChartContainer>
diff --git a/web/pgadmin/static/js/components/PgChart/StreamingChart.jsx b/web/pgadmin/static/js/components/PgChart/StreamingChart.jsx
index 5ccfe3464..34a1a8fea 100644
--- a/web/pgadmin/static/js/components/PgChart/StreamingChart.jsx
+++ b/web/pgadmin/static/js/components/PgChart/StreamingChart.jsx
@@ -5,6 +5,16 @@ import gettext from 'sources/gettext';
 import PropTypes from 'prop-types';
 import { useTheme } from '@material-ui/styles';
 
+const removeExistingTooltips = () => {
+  // Select all elements with the class name "uplot-tooltip"
+  const tooltipLabels = document.querySelectorAll('.uplot-tooltip');
+
+  // Remove each selected element
+  tooltipLabels.forEach((tooltipLabel) => {
+    tooltipLabel.remove();
+  });
+};
+
 function tooltipPlugin(refreshRate) {
   let tooltipTopOffset = -20;
   let tooltipLeftOffset = 10;
@@ -12,13 +22,14 @@ function tooltipPlugin(refreshRate) {
 
   function showTooltip() {
     if(!tooltip) {
+      removeExistingTooltips();
       tooltip = document.createElement('div');
       tooltip.className = 'uplot-tooltip';
       tooltip.style.display = 'block';
       document.body.appendChild(tooltip);
     }
   }
-
+  
   function hideTooltip() {
     tooltip?.remove();
     tooltip = null;
@@ -62,6 +73,7 @@ export default function StreamingChart({xRange=75, data, options, showSecondAxis
   const chartRef = useRef();
   const theme = useTheme();
   const { width, height, ref:containerRef } = useResizeDetector();
+
   const defaultOptions = useMemo(()=> {
     const series = [
       {},
@@ -170,6 +182,7 @@ export default function StreamingChart({xRange=75, data, options, showSecondAxis
       });
     }
 
+
     return {
       title: '',
       width: width,
-- 
2.41.0.windows.1

